#include "filters.h"

err_t addfilter(char *filter)
{
  static char *argv[64];      /* max 64 arguments */
  static char argvdata[4096]; /* max 4k of arguments */
  extern char **environ;
  int argvsize;
  int i;
  int index=0;

  dprintf("addfilter(%s)\n",filter);
  if (!filter) return(e_err);

  for(i=0;(i<63) && filter[index];i++)
    {
      argv[i]=argvdata+index;
      while (filter[index] && (filter[index]!=' '))
	{
	  argvdata[index]=filter[index];
	  index++;
	}
      argvdata[index]=0;
      if (filter[index]) index++;
    }
  argv[i]=NULL;
  
  return(forkfilter(argv,environ));
}

err_t forkfilter(char **argv, char **envp)
{
  int fds[2];
  int pid;

  dprintf("forkfilter(%s, ...)\n",argv[0]);

  /*
  ** fds[0] read
  ** fds[1] write
  */
  if (pipe(fds)<0) perror("pipe()");

  pid=fork();

  if (pid<0) /* error */
    {
      perror("fork()");
      exit(1);
    }
  else if (pid==0) /* child process */
    {
      /*
      ** child reads from stdin and writes to fds[1]
      */
      if (dup2(fds[1],1)!=1) perror("dup2");
      if (close(fds[0])<0) perror("close()");

      do_exec(argv[0],argv,environ);
      return(e_err);
    }
  else /* parent process */
    {
      /*
      ** parent reads from fds[0] and writes to stdout
      */
      if (dup2(fds[0],0)!=0) perror("dup2");
      if (close(fds[1])<0) perror("close()");
      return(e_ok);
    }
  return(e_err);
}


